package lsedit;

import java.awt.*;

import java.util.*;

import java.io.*;

// Entities in a landscape 



public class BaseEntity extends EntityInstance {



    protected static boolean has3Dlook = true;



    public static void set3Dlook(boolean state) {

	has3Dlook = state;

    }



    protected BaseEntity undoEntity; 



    protected BaseEntity() {

    }

      

    public BaseEntity(EntityClass parentClass, String id, Diagram dg) {

	super(parentClass, id, dg);



	undoEntity = new BaseEntity();

    }



    public void saveForUndo() {

	super.saveForUndo(undoEntity);

    }



    public void undo() {

        BaseEntity undoEntity = this.undoEntity;



        this.undoEntity = new BaseEntity(); 

        doSaveForUndo(this.undoEntity); 



	super.undo(undoEntity); 

    }



    public void drawTab(Graphics g, Color c, int tab, boolean fill) {



        double h = Math.min(TAB_HEIGHT, tabHeight());



        ScreenLayout lyt = new ScreenLayout(x()+width()+1, y() + ((h+2)*tab), h, h);



        g.setColor(c);



        if (fill) {

            g.fillRect(lyt.x, lyt.y, lyt.width, lyt.height);

            g.setColor(Color.black);
	}

        g.drawRect(lyt.x, lyt.y, lyt.width, lyt.height);
    }


    protected void setColor(Graphics g) {

	if (highlightFlag && !isOpen()) {

	    g.setColor(Color.red.darker());

	}

	else {

	    g.setColor(getBackground());

	}

    }

    protected void fillFlagAttributes(Graphics g, ScreenLayout rect, Color color) {


        int x1, y1, width1, height1;

        x1      = rect.x;
	y1      = rect.y;
	width1  = rect.width;
	height1 = rect.height;

	// Draw resize points

	g.setColor(color);

	int pdim = (height1 < 20) ? 4 : 6;

        g.fillRect(x1+1,               y1+1,                pdim, pdim);
        g.fillRect(x1+width1/2-pdim/2, y1+1,                pdim, pdim);
        g.fillRect(x1+width1-pdim,     y1+1,                pdim, pdim);
        g.fillRect(x1+1,               y1+height1/2-pdim/2, pdim, pdim);
        g.fillRect(x1+width1-pdim,     y1+height1/2-pdim/2, pdim, pdim);
        g.fillRect(x1+1,               y1+height1-pdim,     pdim, pdim);
        g.fillRect(x1+width1/2-pdim/2, y1+height1-pdim,	    pdim, pdim);
        g.fillRect(x1+width1-pdim,     y1+height1-pdim,     pdim, pdim);
    }

    protected void outlineFlagAttributes(Graphics g, ScreenLayout rect, Color color) {


        int x1, y1, width1, height1;

        x1      = rect.x;
	y1      = rect.y;
	width1  = rect.width;
	height1 = rect.height;

	// Draw resize points

	g.setColor(color);

	int pdim = (height1 < 20) ? 4 : 6;

        g.drawRect(x1+1,               y1+1,                pdim, pdim);
        g.drawRect(x1+width1/2-pdim/2, y1+1,                pdim, pdim);
        g.drawRect(x1+width1-pdim,     y1+1,                pdim, pdim);
        g.drawRect(x1+1,               y1+height1/2-pdim/2, pdim, pdim);
        g.drawRect(x1+width1-pdim,     y1+height1/2-pdim/2, pdim, pdim);
        g.drawRect(x1+1,               y1+height1-pdim,     pdim, pdim);
        g.drawRect(x1+width1/2-pdim/2, y1+height1-pdim,	    pdim, pdim);
        g.drawRect(x1+width1-pdim,     y1+height1-pdim,     pdim, pdim);
    }

    // Put flags around the edges of the box

    protected void drawFlagAttributes(Graphics g, ScreenLayout rect) {


	if (getGroupFlag()) {

	    if (getGroupKeyFlag()) {
		fillFlagAttributes(g, rect, labelColour);
	    }  else {
		outlineFlagAttributes(g, rect, labelColour);
	    }
	}
    }

    protected void setGroupFlag() {

	Graphics	gc;
	ScreenLayout	rect;

	super.setGroupFlag();
	rect = new ScreenLayout(x(), y(), width(), height()); 
	gc   = dg.ls.getDiagramContext();
	drawFlagAttributes(gc, rect);
	gc.dispose();
    }

    protected void clearGroupFlag() {

	if (getGroupFlag()) {
	    ScreenLayout rect;
	    Graphics     gc;
	    
	    super.clearGroupFlag();
	    gc = dg.ls.getDiagramContext();
	    rect = new ScreenLayout(x(), y(), width(), height()); 

	    fillFlagAttributes(gc, rect, getBackground());
	    gc.dispose();
	}
    }

    public void draw(Graphics g) {

    }



    // Assuming p1 is in this object and p2 is outside,

    // return the point that is the intersection between this object 

    // and the line segment p1->p2.



    public RealPoint calculateIntercept(RealPoint p1, RealPoint p2) {

	double x = 0.0;

	double y = 0.0;



	double t, b, l, r;  // Top, bottom, left, and right



	t = this.y()-1;

	b = this.y() + this.height() + 1;

	l = this.x() - 1;

	r = this.x() + this.width() + 1;



	boolean found = true;



	if (p1.x < l || p1.x > r || p1.y < t || p1.y > b) {

	    MsgOut.println("calculateIntercept: p1 is not in box");

	    return new RealPoint(x, y);

	}



	if (p1.x == p2.x && p1.y == p2.y) {

	    MsgOut.println("calculateIntercept: p1 == p2");

	    return new RealPoint(x, y);

	}



	if (r <= p2.x)

	    x = r;

	else if (p2.x < l)

	    x = l;

	else

	    found = false;



	if (found) {

	    // y = mx + b

	    y = p1.y + (x - p1.x) * ( (p2.y - p1.y) / (p2.x - p1.x) );

	    found = ( t <= y && y <= b );

	}



	if (!found) {

	    found = true;

	    if (p2.y <= t)

		y = t;

	    else if (p2.y >= b)

		y = b;

	    else

		found = false;



	    if (found) {

		x = p1.x + (y - p1.y) * ( (p2.x - p1.x) / (p2.y - p1.y) );

		found = (l <= x && x <= r);

	    }

	}



	if (!found) {

	    MsgOut.println("calculateIntercept failed: " + 

		p1.x + " " + p1.y + " " + p2.x + " " + p2.y); 

	}



	return new RealPoint(x, y);

    }



    public boolean isPointOver(int x, int y, ScreenLayout lyt) {

	return lyt.inside(x, y);

    }



    public boolean isPointOver(int x, int y) {

        ScreenLayout rect = new ScreenLayout(getLayout());



        return isPointOver(x, y, rect);

    }



    public int overResizeTab(int x1, int y1) {

	double x0, y0, width0, height0;

	x0      = x();
	y0      = y();
	width0  = width();
	height0 = height();

	ScreenLayout rect = 

	    new ScreenLayout(x0+6, y0+6, width0-12, height0-12);



        if (isPointOver(x1, y1, rect))

	    return RSZ_NONE;



	rect = new ScreenLayout(x0, y0, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_NW;



	rect = new ScreenLayout(x0+width0/2-3, y0, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_N;



	rect = new ScreenLayout(x0+width0-6, y0, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_NE;



	rect = new ScreenLayout(x0, y0+height0/2-3, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_W;



	rect = new ScreenLayout(x0+width0-6, y0+height0/2-3, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_E;



	rect = new ScreenLayout(x0, y0+height0-6, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_SW;



	rect = new ScreenLayout(x0+width0/2-3, y0+height0-6, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_S;



	rect = new ScreenLayout(x0+width0-6, y0+height0-6, 6, 6);



        if (isPointOver(x1, y1, rect))

	    return RSZ_SE;



	return RSZ_NONE;

    }



    public boolean isPointOverTab(int x, int y, int tab) {

        double h = Math.min(TAB_HEIGHT, tabHeight());



        ScreenLayout lyt =

            new ScreenLayout(this.x()+width()+1, this.y() + ((h+4)*tab), h, h);

 

	return (x >= lyt.x && x < lyt.x+lyt.width &&

                y >= lyt.y && y < lyt.y+lyt.height);

    }



    public boolean isPointOverIO(EdgePoint pt, int x, int y) {

        ScreenPoint spt = new ScreenPoint(pt.x, pt.y);



	return ((spt.x - Bend.SIZE/2) < x && x < (spt.x + Bend.SIZE/2) &&

	        (spt.y - Bend.SIZE/2) < y && y < (spt.y + Bend.SIZE/2));

    }

 

    public boolean containsLayout(Layout lyt) {

	return (x() < lyt.x && lyt.x+lyt.width < x()+width() &&

		y() < lyt.y && lyt.y+lyt.height < y()+height()); 

    }



    public boolean intersectsLayout(Layout lyt) {

	// Return true if the intersection of passed layout and 

	// entities layout is non-null



	// It overlaps if any corner of layout is contained in

	// entity, or vice versa.



	ScreenLayout rgn = new ScreenLayout(lyt); 

	ScreenLayout box = new ScreenLayout(this.x(), this.y(), width(), height());



	return rgn.intersects(box);

    }



    public void drawHighlight(Graphics g) {

        g.setColor(Color.white);



	ScreenLayout rect = new ScreenLayout(x(), y(), width(), height());



        g.drawRect(rect.x, rect.y, rect.width, rect.height);

        g.drawRect(rect.x+1, rect.y+1, rect.width-1, rect.height-1);

    }



    public void undrawHighlight(Graphics g) {

        setColor(g);



	ScreenLayout rect = new ScreenLayout(x(), y(), width(), height());



        g.draw3DRect(rect.x, rect.y, rect.width, rect.height, true);

        g.draw3DRect(rect.x+1, rect.y+1, rect.width-1, rect.height-1, true);

    }



    public void drawOutline(Graphics g, Layout lyt) {

	ScreenLayout rect = new ScreenLayout(lyt); 



	g.drawRect(rect.x, rect.y, rect.width, rect.height);

	// g.drawRect(rect.x-1, rect.y-1, rect.width+1, rect.height+1);

    }



    private EdgePoint 
    getPoint(EdgePoint[] pts, RelationClass rc, int side) {

	int	  nid;
	EdgePoint cached;


	nid    = rc.getNid();
	cached = pts[nid];

	// Cache calculated points

	if (cached == null || cached.getRc() != rc) {

	    double f  = rc.getIOfactor();
	    double wf = 0.0;
	    double hf = 0.0;

	    switch(side)
	    {

	    case EdgePoint.TOP:
		wf = f;			// Put at entity x + width * f 
		hf = 0.0;		// But at top
		break;
	    case EdgePoint.BOTTOM:
		wf = f;
		hf = 1.0;		// But at bottom
		break;
	    case EdgePoint.LEFT:
		wf = 0.0;		// But at left
		hf = f;
		break;
	    default:
		wf = 1.0;		// Put at right
		hf = f;
		break;

	    }
	    if (cached == null) {
		pts[nid] = cached = new EdgePoint(this, rc, wf, hf);
	    } else {
		cached.setRc(rc);
	    }
	    cached.rescale();		// Compute actual point given current position of e
	    cached.isDefault = true;
	    cached.side      = side;
	}

	return cached;

    }



    public EdgePoint getPoint(RelationClass rc, int side) {

	EdgePoint[] cache;

	switch(side) {
	case EdgePoint.TOP:
	    cache = topPoints;
	    if (cache == null) {
		topPoints = cache = new EdgePoint[dg.numRelationClasses()];
	    }
	    break;
	case EdgePoint.BOTTOM:
	    cache = bottomPoints;
	    if (cache == null) {
		bottomPoints = cache = new EdgePoint[dg.numRelationClasses()];
	    }
	    break;
	case EdgePoint.LEFT:
	    cache = leftPoints;
	    if (cache == null) {
		leftPoints = cache = new EdgePoint[dg.numRelationClasses()];
	    }
	    break;
	default:
	    cache = rightPoints;
	    if (cache == null) {
		rightPoints = cache = new EdgePoint[dg.numRelationClasses()];
	}    }
        return getPoint(cache, rc, side);
    }


    // At what point does the ri relation hit this, given that it goes from the box specified by srcLyt to dstLyt
    // N.B. Most of the time anyway it appears that srcLyt is the srcLyt of this.

    public EdgePoint getOutPoint(RelationInstance ri, int edge_mode, Layout srcLyt, Layout dstLyt) 

    {

	RelationClass rc = ri.getRelationClass();
	int nid = rc.getNid();

	switch(edge_mode)
	{

	case Diagram.TB_EDGE:

	    {

	    BaseEntity src = (BaseEntity) ri.getSrc();



	    if (this == src || src.isContainedBy(this)) {
		return getPoint(rc, EdgePoint.BOTTOM);
	    }
	    return getPoint(rc, EdgePoint.TOP);

	    }



	default:

	    if ((dstLyt.y - (srcLyt.y+srcLyt.height)) > SEP_THRESHOLD) {

		// dstLyt strictly below srcLyt
		return getPoint(rc, EdgePoint.BOTTOM);

	    }

	    if ((srcLyt.y - (dstLyt.y+dstLyt.height)) > SEP_THRESHOLD) {

		// srcLyt strictly below dstLyt
		return getPoint(rc, EdgePoint.TOP);

	    }

	    if ((dstLyt.x - (srcLyt.x+srcLyt.width)) > SEP_THRESHOLD) {
		return getPoint(rc, EdgePoint.RIGHT);
	    }

	    if ((srcLyt.x - (dstLyt.x+dstLyt.width)) > SEP_THRESHOLD) {
		return getPoint(rc, EdgePoint.LEFT);
	    }

	    if (dstLyt.y > (srcLyt.y+srcLyt.height)) {
		return getPoint(rc, EdgePoint.BOTTOM);
	    }
	    return getPoint(rc, EdgePoint.TOP);

	}

    }



    protected EdgePoint testMouseOverIO(EdgePoint[] pts, int x, int y) {

	if (pts == null)

	    return null;



	for (int i = 0; i < pts.length; i++) {

	    EdgePoint pt = pts[i];



	    if (pt != null) {

		if (isPointOverIO(pt, x, y))

		    return pt;

	    }

	}



	return null;

    }



    public EdgePoint getMouseOverIO(int x, int y) {

	EdgePoint pt = testMouseOverIO(topPoints, x, y);
	if (pt != null) {
	    return pt;
	}


	pt = testMouseOverIO(bottomPoints, x, y);
	if (pt != null) {
	    return pt;
	}


	pt = testMouseOverIO(leftPoints, x, y);
	if (pt != null) {
	    return pt;
	}


	return testMouseOverIO(rightPoints, x, y);
    }



    protected void writePoints(PrintStream ps, EdgePoint[] pts, String name) {

	if (pts == null)

	    return;



	boolean isDefault = true;



	for (int i = 1; i < pts.length; i++) {

	    if (pts[i] != null)

		isDefault = isDefault && pts[i].isDefault;

	}



	if (isDefault) {

	    return;

	}



	ps.print("  " + name + " = ( ");

	

	for (int i = 1; i < pts.length; i++) {

	    if (pts[i] != null && !pts[i].isDefault) {

		ps.print("(" + pts[i].getRc().getId() + " " + pts[i].wf + " " + pts[i].hf + ") ");

	    }

	}



	ps.print(")\n");

    }



    public void writeIOpoints(PrintStream ps) {

	writePoints(ps, topPoints, INPOINT_ID);

	writePoints(ps, bottomPoints, OUTPOINT_ID);

	writePoints(ps, leftPoints, LEFTPOINT_ID);

	writePoints(ps, rightPoints, RIGHTPOINT_ID);

    }

}

