package lsedit;

import java.applet.*; 

import java.awt.*;



public class RelAttributeEditDialog extends Dialog {

    protected static final int COLS = 50;



    protected EntityInstance e;



    protected Button okButton, cancelButton;

    protected TextArea textArea;

    protected TextField labelField;



    protected String addNL(String instr, int cols) {

	String outstr = "";



	int spos = 0;

	int epos;

	int len  = instr.length();



	while (spos+cols < len) {

	    epos = spos+cols-1;



	    while (epos > spos && instr.charAt(epos) != ' ')

	        epos--; 



	    if (epos == spos) 

	       epos = cols;



	    outstr = outstr + instr.substring(spos, epos) + "\n";

	    spos = epos+1;

	}



	return (outstr + instr.substring(spos));

    }



    protected String stripNL(String instr) {

	return instr.replace('\n', ' ');

    }



    public RelAttributeEditDialog(EntityInstance e, Frame f) {

        // Create a dialog

        super(f, "Edit Attributes", true);



	this.e = e;



        // Create and use a BorderLayout manager

        //

        // +-----------------------+

        // |     [Entity North]    |

        // |     [Label Center]    |

        // | +-------South-------+ |

        // | |    [Desc North]   | |

        // | | [TextArea Center] | |

        // | | [OK Cancel South] | |

        // | +-------------------+ |

        // +-----------------------+



        this.setLayout(new BorderLayout());



        Panel p;



        p = new Panel();

        p.setLayout(new FlowLayout(FlowLayout.LEFT));

        p.add(new Label("Entity ID:", Label.LEFT));

	p.add(new Label(e.getId(), Label.LEFT));

        this.add("North", p);



        p = new Panel();

        p.setLayout(new FlowLayout(FlowLayout.LEFT));

        p.add(new Label("Label:", Label.LEFT));

        labelField = new TextField(e.getLabel(), 50);

        p.add(labelField);

        this.add("Center", p);



        Panel bp = new Panel();

        bp.setLayout(new BorderLayout());

        bp.add("North", new Label("Description:", Label.LEFT));

        textArea = new TextArea(addNL(e.getDescription(), COLS), 10, COLS);

        bp.add("Center", textArea);



        p = new Panel();

        okButton = new Button("OK");

        p.setLayout(new FlowLayout(FlowLayout.RIGHT, 15, 15));

        p.add(okButton);

        cancelButton = new Button("Cancel");

        p.add(cancelButton);

        bp.add("South", p);



        this.add("South", bp);



        // Resize the window to the preferred size of its components

        this.pack();

    }



    // Update description if OK button clicked 

    public boolean action(Event ev, Object arg) {

	if (ev.target == okButton || ev.target == cancelButton) {

	    if (ev.target == okButton) {

		e.setLabel(labelField.getText()); 

		e.setDescription(stripNL(textArea.getText()));

	    }

	    this.hide();

	    this.dispose();

	    return true;

	}

	else return false;

    }



    public static void Create(Applet ap, EntityInstance e) {

	Container c = ap; 



	do { 

	    c = c.getParent(); 

	} while (!(c instanceof Frame)); 



	RelAttributeEditDialog teb = new RelAttributeEditDialog(e, (Frame) c); 



	teb.show(); 

    }

}

