package lsedit;

import java.applet.*;

import java.awt.*;

import java.util.*;



public class ResultBox extends TabbedBox {



    protected static final Font textFont =

		new Font("Helvetica", Font.PLAIN, 11); 



    protected static final Font titleFont =

		new Font("Helvetica", Font.BOLD, 14);



    protected static final String helpStr =

	"This box shows the results of queries, and groupings";



    protected String text; 

    protected String title;



    protected int lineNo = 0;



    protected ClickHandler ch = null;



    protected Vector objects;



    protected void processLine(Graphics g, String line, 

				int xpos, int ypos, int w, int h) 

    {

        FontMetrics fm = g.getFontMetrics();



	int ht = Util.fontHeight(fm);



	while (line.length() > 0) {



	    int ind = line.indexOf("<a href='");



	    if (ind >= 0) {

		String dstr;



	        if (ind > 0) {

		    dstr = line.substring(0, ind);



                    Util.drawStringClipped(g, dstr, xpos, ypos, w, h);

	

		    xpos += fm.stringWidth(dstr);

	        }

		

		// Now process link tag



		int eind = line.indexOf(">");



		String tagLine = line.substring(ind+9, eind);



		line = line.substring(eind+1);



		ind = tagLine.indexOf("'");



		String link = tagLine.substring(0, ind);



		tagLine = tagLine.substring(ind+1);



		ind = tagLine.indexOf("target='");



		tagLine = tagLine.substring(ind+8);



		ind = tagLine.indexOf("'");



		String target = tagLine.substring(0, ind);

		

		ind = line.indexOf("</a>");



		dstr = line.substring(0, ind);



		int len = fm.stringWidth(dstr);



		TextLink tl = new TextLink(link, target, xpos, ypos, len, ht);



		line = line.substring(ind+4);



		g.setColor(Color.blue);



            	Util.drawStringClipped(g, dstr, xpos, ypos, w, h, false, true);



		xpos += len;



		g.setColor(Color.black);

	    }

	    else {

            	Util.drawStringClipped(g, line, xpos, ypos, w, h);

		return;

	    }

	}

    }



    // Protected methods 



    protected void drawContents(Diagram dg, Graphics g, boolean fullInfo) {



	// Draw title 



	Rectangle r = bounds();



        g.setFont(titleFont);

        g.setColor(titleColor);



        int h = Util.fontHeight(titleFont);

			// Util.fontHeight(g.getFontMetrics());



        int xpos = GAP*2;

        int ypos = GAP;



        Util.drawStringClipped(g, title, xpos, ypos, r.width-GAP*2, h);

	ypos += h + 7;



        // Now lines of text



        g.setColor(Color.black);

        g.setFont(textFont);



        FontMetrics fm = g.getFontMetrics();



        h = Util.fontHeight(textFont) - 2;



        // Output as many lines as we can of the description within the

        // text box provided by parsing the description for words.



	int width = r.width-GAP*2;



	if (scrollBar != null && scrollBar.isVisible())

	    width -= (SB_WIDTH+GAP);



	StringLinizer sl = new StringLinizer(text, fm, width);



	int ln = 0;



	int mypos = r.height-h-GAP;



        while (sl.hasMoreLines() && ypos < mypos) {

	    String line = sl.nextLine();

	     

	    if (ln >= lineNo) {

		processLine(g, line, xpos, ypos, r.width-GAP*2, h);

		ypos += (h+2);

	    }



	    ln++;

        } 

    }





    // --------------

    // Public methods 

    // --------------



    public ResultBox(LandscapeViewerCore ls) {

	super(ls, "Results", 140);

    }



    public void set(String title, String text, ClickHandler ch, boolean act) {

	this.ch = ch;

	this.title = title;

	this.text = text; 

	if (act)

	    ls.activateTabBox(this);

	repaint();

    }



    public void set(String title, String text, ClickHandler ch) {

	set(title, text, ch, true);

    }



    public void set(String title, String text) {

	set(title, text, null, true);

    }



    public void clear() {

	ch = null;

	title = "";

	text = "";



	if (active)

	    repaint();

    }



    public boolean mouseMotion(Event ev, int x, int y) {

	ls.setHelpPopup(helpStr, x, y);

	return true;

    }



    public boolean handleEvent(Diagram dg, Graphics gc, Event event) {

	return super.handleEvent(dg, gc, event);

    }

}

