package lsedit;

import java.util.*;

import java.awt.*;



public class StringLinizer extends Object {

    protected FontMetrics fm;

    protected int width;

    protected StringTokenizer st;



    protected String theNextToken1 = null;

    protected String theNextToken2 = null;



    protected boolean hasMoreTokens() {

	return (theNextToken1 != null) || st.hasMoreTokens();

    }



    protected String nextToken() {

	if (theNextToken1 != null) {

	    String nt = theNextToken1;

	    theNextToken1 = theNextToken2;

	    theNextToken2 = null;

	    return nt;

	}



	return st.nextToken();

    }



    protected String startOfTag() {

	String tag = "<";



	String word;



	if (!hasMoreTokens())

	    return tag;



	word = nextToken();



	tag += word;



	if (!word.equals("a") || !hasMoreTokens())

	    return tag;



	word = nextToken();



	tag += word;



	if (!word.equals(" ") || !hasMoreTokens())

	    return tag;



	return tag + nextToken();

    }



    // Exported routines

    

    public StringLinizer(String str, FontMetrics fm, int width) {

	this.fm = fm;

	this.width = width;



	st = new StringTokenizer(str, " <>=\n\r\t\"", true);

    }



    public boolean hasMoreLines() {

	return hasMoreTokens();

    }



    public String nextLine() {

	String str = "";

	String pstr = "";



        while (hasMoreTokens()) {

	    String word = nextToken();

	    boolean tabbed = false;



	    String tag = "";



	    if (word.equals("<")) {

		tag = startOfTag();



		if (tag.equals("<a href") || tag.equals("</a")) {

		    do {

		        word = nextToken();

		        tag += word;

		    } while(!word.equals(">") );



		    if (!hasMoreTokens())

		        return str + tag;



		    word = nextToken();

		}

		else {

		    word = tag;

		    tag = "";

		}

	    }

	    else if (word.startsWith("<")) {

		int ind = word.indexOf(">");



		tag = word.substring(0, ind+1);

		word = word.substring(ind+1);

	    }



	    if (word.equals("\r")) {

		if (hasMoreTokens()) {

		    word = nextToken();

		    if (!word.equals("\n")) {

			theNextToken1 = tag + word;

			theNextToken2 = null;

			tag = "";

		    }

		}

		return str + tag;

	    }

	    else if (word.equals("\n")) {

		return str + tag ;

	    }

	    else if (word.equals("\t")) {

		word = "    ";

		tabbed = true;

		str += tag;

		tag = "";

	    }

	    else if (word.equals("\"")) {

		String qstr = "\"";

	

		do {

		    word = nextToken();

		    qstr += word;

		} while (!word.equals("\""));



		word = qstr;

	    }



	    if (fm.stringWidth(pstr + word) > width) {

		if (!tabbed)  {

		    theNextToken1 = "    ";

		    theNextToken2 = tag + word;

		}

	

		return str;

	    }

	   

	    pstr += word; 

	    str += (tag + word);

	}



	return str;

    }

}

