package lsedit;

public class Version {
    public final static int MAJOR = 6;
    public final static int MINOR = 0;
    public final static int BUILD = 3;
	public final static String COMPILED = "Monday, 15 April 2002";

	public static String Number()
	{
		return(MAJOR + "." + MINOR + "." + BUILD);
	}

	public static String CompileDate()
	{
		return("Compiled: " + COMPILED);
	}

	private static String Detail(String property)
	{
		String result;

		try {
			result = System.getProperty(property);
		} catch (Exception e) {
			result = "";
		};
		return(result);
	}

	public static String Details()
	{
		String result;

		// System.getProperties().list(System.out);

		result  = Version.Number() + "\n\n";


		try	{ //set if possible
			result += Version.CompileDate() + "\n";
			result += "Author: Written by Gary Farmaner\n\n";
			result += "Run Time Engine: " + Detail("java.vendor") + " " + Detail("java.version") + "\n";
			result += "Virtual Machine: " + Detail("java.vm.name") + " " + Detail("java.vm.version") + "\n";
			result += "V/M Vendor: " + Detail("java.vm.vendor") + "\n"; 
			result += "Operating System: " + Detail("os.name") + " " + Detail("os.arch") + " " + Detail("os.version") + "\n";
			result += "Patch level: " + Detail("sun.os.patch.level") + "\n";
			result += "User id: " + Detail("user.name") + "\n";
			result += "Directory: " + Detail("user.dir") + "\n";

		} catch (Exception e) {}

		return(result);
	}
}

/* History:
   6.0.0 -- Changes by Ian Davis

   April 4th (All day) 9:30-10pm
   
   Placed all source in package lsedit.
   Fixed minor compile problems under latest version of sun.
   Added code to close window when x pressed in Top Right hand corner.
   Enhanced the version information.
   Changed file prompt to prompt using java.awt.FileDialog
   Made right tabbed box go away completely when turned off
   Activated appropriate right tab so will display properly when turned back on

   April 5th           10:30-4pm
   Removed some debug output
   Made animation optional to improve refresh rate.
   By default now in options menu "Show animations" is set to false.
   Changed cursor back to default after double click of mouse
   Removed some null pointer exceptions (rather by guessing desired behaviour)

   6.0.1 

   April 7th
   Corrected bug in drawing edges introduced in 6.0.0
   Worked towards understanding lsedit layout strategy
   Cleaned up code
   Traced layout problem to   Diagram.setToViewport()
   Attempting to decipher what occurs beneath this.
   Quite bemused since right now nothing makes much sense.
   Concerns include:
    (1) rootInstance.getChildBoundingBoxLocal();
          this only gets the bounding box of its own children, not its decendants.
          Is there a presumption that children strictly contained within parent.
    (2) old formula for y scale was bizarre.
          yScale = (height-width/16)/bb.height;  [ changed to function purely of height]
    (3) don't understand dx and dy at all..  Don't see how using only height and width one
        can correct positions of children.
    (4) translateChildrenLocal changes local values using dx and dy for both children and bends
        But bends not considered in computing what the bounding box was

   April 8th-10
   Released 6.0.1

   6.0.2

   Began exploring the refresh problem
   Tracked bug down to repaints() on both mouse down and mouse up pairs
   Have changed code to paint group flags in tight relationship to setting/clearing group flag
   Have delayed painting of group to be moved until move actually begins to avoid need to refresh
   Removed debug messages
   Released 6.0.2

   6.0.3

   April 14th

   Corrected the way in which point positions were cached.  There was a problem that simply rescaling
   the point positions when want to actually say discard the cache of point positions doesn't work
   because the x,y positions of the objects containing these points may not yet be right.




*/
